
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.awt.image.PixelGrabber;
import java.io.File;

import javax.imageio.ImageIO;
import javax.swing.*;

public class JFrame1 extends JFrame implements ActionListener {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1230444169837772400L;
	public BufferedImage image1;
	public BufferedImage image2;
	public BufferedImage image3;
	
	public final int WIDTH = 128;
	public final int HEIGHT = 128;

	public String text1 = "";
	public String text2 = "";
	public String testImage;
	

	public JLabel l1;
	public JLabel l2;
	public JLabel l3;
	public JLabel l4;
	
	public JButton b1;
	public JButton b2;
	public JButton b3;
	public JButton b4;
	public JButton b5;
	public JButton b6;
	public JButton b7;
	
	
	public JTextArea ta1;
	public JTextArea ta2;
	
	public Graphics g1;
	public Graphics g2;
	public Graphics g3;
	
	public int[] pxd1;
	public int[] pxd2;
	public int[] pxd3;
	
	public double[] fr;
	public double[] fi;
	public double[][] sr;
	public double[][] si;
	public double[][] sp;
	public int nc = 0;
	public double dRange = 70D;
	
	public final int FFT = 1;
	public final int IFFT = -1;

	

	public static void main(String[] args){
		new JFrame1("FFT test");
	}
	
	public JFrame1(String title)  {
		super(title);
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		
		
		image1 = new BufferedImage(WIDTH, HEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		image2 = new BufferedImage(WIDTH, HEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		image3 = new BufferedImage(WIDTH, HEIGHT,BufferedImage.TYPE_4BYTE_ABGR); 
		
		pxd1 = new int[WIDTH*HEIGHT];
		pxd2 = new int[WIDTH*HEIGHT];
		pxd3 = new int[WIDTH*HEIGHT];
		fr = new double[WIDTH];
		fi = new double[WIDTH];
		
		sr = new double[WIDTH][HEIGHT];
		si = new double[WIDTH][HEIGHT];
		sp = new double[WIDTH][HEIGHT];
		
		
		
		
		JPanel p1 = new JPanel();
		p1.setLayout(null);
		preparePai(WIDTH, HEIGHT, image1, g1);
		l1 = new JLabel(new ImageIcon(image1));
		l1.setBounds(50,20,128,128);
		p1.add(l1);

		preparePai(WIDTH, HEIGHT, image2, g2);
		l2 = new JLabel(new ImageIcon(image2));
		l2.setBounds(250,20,128,128);
		p1.add(l2);
		
		preparePai(WIDTH, HEIGHT, image3, g3);
		l3 = new JLabel(new ImageIcon(image3));
		l3.setBounds(450,20,128,128);
		p1.add(l3);
		
		l4 = new JLabel();
		l4.setBounds(935,50,150,20);
		
		l4.setText(String.valueOf(nc)+" / 64");
		p1.add(l4);

	
		b1 = new JButton("Open Image");
		b1.setBounds(650,20,150,20);
		p1.add(b1);
		b1.addActionListener(this);
		
		b2 = new JButton("Full Range");
		b2.setBounds(650,50,150,20);
		p1.add(b2);
		b2.addActionListener(this);
		

		b3 = new JButton("High Pass");
		b3.setBounds(650,80,150,20);
		p1.add(b3);
		b3.addActionListener(this);
		
		b4 = new JButton("Low Pass");
		b4.setBounds(650,110,150,20);
		p1.add(b4);
		b4.addActionListener(this);
		
		b5 = new JButton("Cut ＋");
		b5.setBounds(900,20,100,20);
		p1.add(b5);
		b5.addActionListener(this);
		
		b6 = new JButton("Cut －");
		b6.setBounds(900,80,100,20);
		p1.add(b6);
		b6.addActionListener(this);
	
		ta1 = new JTextArea("");
		JScrollPane sc1 = new JScrollPane();
		sc1.setViewportView(ta1);
		sc1.setBounds(20,200,610,450);
		p1.add(sc1);
		
		ta2 = new JTextArea("");
		JScrollPane sc2 = new JScrollPane();
		sc2.setViewportView(ta2);
		sc2.setBounds(650,200,610,450);
		p1.add(sc2);
		
		getContentPane().add(p1, BorderLayout.CENTER);

		addWindowListener(new WindowClosing() );
	    setVisible(true);
	    setExtendedState(JFrame.MAXIMIZED_BOTH);
	}
	public void preparePai(int width, int height, BufferedImage img, Graphics g){
		
		g = img.createGraphics();
		g.setColor(Color.GREEN);
		g.fillRect(0,0,width, height);		
	}

	public void setPixel(int x, int y, int pixel, Graphics g){
		try {
			
	        int red = pixel >> 16 & 255;
	        int green = pixel >> 8 & 255;
	        int blue = pixel & 255;
	       
			g.setColor(new Color(red,green,blue));
			g.drawRect(x, y, 1, 1);
		} catch (Exception e){
		}
	}
	public int getPixel(int x, int y, int[] pxd){
		int result = 0;
		int pixel = pxd[x + y * WIDTH];
        int red = pixel >> 16 & 255;
        int green = pixel >> 8 & 255;
        int blue = pixel & 255;
 		double light = (double)red * 0.299 + (double)green * 0.587 + (double)blue * 0.114;
        result = (int)light;
		return result;
	}

	public class WindowClosing extends WindowAdapter{
		public void windowClosing(WindowEvent e){
			int ans = JOptionPane.showConfirmDialog(JFrame1.this, "終了しますか？");
			if (ans == JOptionPane.YES_OPTION){
				System.exit(0);  
			}
		}
	}
	
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == b1){
			//画像の選択		
			ta1.setText("");
			ta2.setText("");
			
			text1 = "";
			text2 = "";
			
			String testImage = "";
			
			JFileChooser fc = new JFileChooser( "." );
			int result = fc.showOpenDialog( null );
			if(result==JFileChooser.APPROVE_OPTION) {
				testImage = fc.getSelectedFile().getPath();

			}
			if(result==JFileChooser.CANCEL_OPTION) {
				//ta1.setText("画像の読み込みを取り消しました");
				return;
			}
			if(result==JFileChooser.ERROR_OPTION) {
				//ta1.setText( "画像が開けません" );
				return;
			}
			
			ta1.setText("画像ファイル="+testImage);
			
			BufferedImage image1 = null;
			try {image1 = ImageIO.read(new File(testImage));}
			catch (Exception e1) { e1.printStackTrace(); image1 = null;}
					
			PixelGrabber pg = new PixelGrabber(image1 , 0 , 0 , WIDTH, HEIGHT,pxd1,0,WIDTH);
			try { pg.grabPixels(); }
			catch (InterruptedException e2) { }
			l1.setIcon(new ImageIcon(image1));
			
			BufferedImage image2 = new BufferedImage(WIDTH,HEIGHT,BufferedImage.TYPE_4BYTE_ABGR);
			g2 = image2.createGraphics();
			g2.setColor(Color.GREEN);
			g2.fillRect(0,0,WIDTH,HEIGHT);
			l2.setIcon(new ImageIcon(image2));
			
			BufferedImage image3 = new BufferedImage(WIDTH,HEIGHT,BufferedImage.TYPE_4BYTE_ABGR);
			g3 = image3.createGraphics();
			g3.setColor(Color.GREEN);
			g3.fillRect(0,0,WIDTH,HEIGHT);
			l3.setIcon(new ImageIcon(image3));
			
		} else if(e.getSource() == b2){
			BufferedImage image2 = new BufferedImage(WIDTH,HEIGHT,BufferedImage.TYPE_4BYTE_ABGR);
			g2 = image2.createGraphics();
			g2.setColor(Color.GREEN);
			g2.fillRect(0,0,WIDTH,HEIGHT);
			l2.setIcon(new ImageIcon(image2));
			
			BufferedImage image3 = new BufferedImage(WIDTH,HEIGHT,BufferedImage.TYPE_4BYTE_ABGR);
			g3 = image3.createGraphics();
			g3.setColor(Color.GREEN);
			g3.fillRect(0,0,WIDTH,HEIGHT);
			l3.setIcon(new ImageIcon(image3));
			
			fft2(WIDTH, HEIGHT, pxd1);
			displaySpectrum(WIDTH, HEIGHT, g2);
			text1 += "*** Full Range ***\n";
			ifft2(WIDTH, HEIGHT, g3);
			l3.repaint();
			ta1.setText(text1);
			ta1.setText(text1);
			
		
		} else if(e.getSource() == b3){
			BufferedImage image2 = new BufferedImage(WIDTH,HEIGHT,BufferedImage.TYPE_4BYTE_ABGR);
			g2 = image2.createGraphics();
			g2.setColor(Color.GREEN);
			g2.fillRect(0,0,WIDTH,HEIGHT);
			l2.setIcon(new ImageIcon(image2));
			
			BufferedImage image3 = new BufferedImage(WIDTH,HEIGHT,BufferedImage.TYPE_4BYTE_ABGR);
			g3 = image3.createGraphics();
			g3.setColor(Color.GREEN);
			g3.fillRect(0,0,WIDTH,HEIGHT);
			l3.setIcon(new ImageIcon(image3));
			
			fft2(WIDTH, HEIGHT, pxd1);
			highPassFilter(WIDTH, HEIGHT, nc);
			displaySpectrum(WIDTH, HEIGHT, g2);
			text1 += "*** High Pass Filter *** (" + nc + "/64)\n";
			ta1.setText(text1);
			ifft2(WIDTH, HEIGHT, g3);
			l3.repaint();
		} else if(e.getSource() == b4){
			BufferedImage image2 = new BufferedImage(WIDTH,HEIGHT,BufferedImage.TYPE_4BYTE_ABGR);
			g2 = image2.createGraphics();
			g2.setColor(Color.GREEN);
			g2.fillRect(0,0,WIDTH,HEIGHT);
			l2.setIcon(new ImageIcon(image2));
			
			BufferedImage image3 = new BufferedImage(WIDTH,HEIGHT,BufferedImage.TYPE_4BYTE_ABGR);
			g3 = image3.createGraphics();
			g3.setColor(Color.GREEN);
			g3.fillRect(0,0,WIDTH,HEIGHT);
			l3.setIcon(new ImageIcon(image3));
			
			fft2(WIDTH, HEIGHT, pxd1);
			lowPassFilter(WIDTH, HEIGHT, nc);
			displaySpectrum(WIDTH, HEIGHT, g2);
			text1 += "*** Low Pass Filter *** (" + nc + "/64)\n";
			ta1.setText(text1);
			ifft2(WIDTH, HEIGHT, g3);
			l3.repaint();
		} else if(e.getSource() == b5){
			++nc;
			if (nc >= Math.min(WIDTH, HEIGHT)/2) nc = Math.min(WIDTH, HEIGHT)/2-1;
			l4.setText(String.valueOf(nc)+" / 64");
		} else if(e.getSource() == b6) {
			--nc;
			if (nc < 0) nc = 0;
			l4.setText(String.valueOf(nc)+" / 64");
		}
	}
	public void fft1(int flag, int n){
		int i,m,iw,j,k,kp,kp2,n2;
		double arg,darg, c, s, wr, wi, xa, ya;
		// Bit Reversal
		j = 0;
		for (i = 0; i < n - 1; i++){
			if (i < j){
				xa = fr[i];
				fr[i] = fr[j];
				fr[j] = xa;
				ya = fi[i];
				fi[i] = fi[j];
				fi[j]= ya;
			}
			
			n2 = n/2;
			while ( j >= n2){
				j = j - n2;
				n2 = n2 / 2;
			}
			j =  j + n2;
		}
	//fft
		m = 0;
		n2 = n;
		while(n2 != 1){
			m = m + 1;
			n2 = n2 / 2;
		}
		for (k = 1; k <= m; k++){
			kp = power2(k);
			kp2 = kp /2;
			darg = - flag * Math.PI /kp2;
			arg = 0D;
			for (j = 0; j < kp2 ; j++){
				c = Math.cos(arg);
				s = Math.sin(arg);
				arg = arg + darg;
				for (i = j ; i < n ; i = i + kp){
					iw = i + kp2;
					wr = fr[iw] * c - fi[iw] * s;
					wi = fr[iw] * s + fi[iw] * c;
					fr[iw] = fr[i] - wr;
					fi[iw] = fi[i] - wi;
					fr[i] = fr[i] + wr;
					fi[i] = fi[i] + wi;
				}
			}
		}
		if (flag == FFT){
			for (i = 0; i < n; i++){
				fr[i]= fr[i]/(double)n;
				fi[i]= fi[i]/(double)n;
			}
		
		}
	}
	public void fft2(int nx, int ny, int[] pxd){
		for (int j = 0; j < ny; j++){
			for (int i = 0; i < nx; i++){
				int gray = getPixel(i, j, pxd);
				fr[i]= (double)gray;
				fi[i]= 0D;
			}
			fft1(FFT, 128);
			for (int i = 0; i < nx; i++){
				sr[i][j]= fr[i];
				si[i][j]= fi[i];
			}
		}
		for (int i = 0 ; i < nx; i++){
			for (int j = 0; j < ny; j++){
				fr[j] = sr[i][j];
				fi[j] = si[i][j];
			}
			fft1(FFT, 128);
			for (int j = 0; j < ny; j++){
				sr[i][j]=fr[j];
				si[i][j]=fi[j];
			}
		}
	}
	
	public void displaySpectrum(int nx, int ny, Graphics g){
		int max = -10000000;
		int min = 10000000;
		int db1;
		for(int j = 0; j < ny; j++){
			for (int i = 0 ; i < nx; i++){
				double pw = sr[i][j]*sr[i][j]+si[i][j]*si[i][j];
				db1=(int)(10*Math.log(pw)+dRange);
				if (db1 > max) max = db1;
				if (db1 < min) min = db1;
				sp[i][j]= db1;
			}
		}
		double a;
		for (int j = 0; j < ny/2; j++){
			for (int i = 0; i < nx/2; i++){
				a = sp[i][j];
				sp[i][j] = sp[i + nx/2][j + ny/2];
				sp[i + nx/2][j + ny/2] = a;
			}
			for (int i = nx/2; i < nx; i++){
				a = sp[i][j];
				sp[i][j] = sp[i - nx/2][j + ny/2];
				sp[i - nx/2][j + ny/2] = a;
			}
		}
		for (int j = 0; j < ny; j++){
			for (int i = 0; i < nx; i++){
				double db = sp[i][j] + dRange;
				if (db < 0) db = 0;
				int gray = (int)(255*db/(max+dRange));
				int pixel = gray * (256*256+256+1);
				setPixel(i,j,pixel, g);
			}
		}
	}
	
	public void highPassFilter(int nx, int ny, int nc){
		// High Pass Filter
		for (int j = 0; j < ny; j++){
			if (j < nc || j >= (ny - nc)){
				for (int i = 0; i < nx; i++){
					if (i == 0 && j == 0) break;
					if (i < nc || i >= (nx - nc)){
						sr[i][j] = 0D;
						si[i][j] = 0D;
					}
				}	
			}
		}
	}
	public void lowPassFilter(int nx, int ny, int nc){
		// Low Pass Filter
		for (int j = ny / 2 - nc; j <= (ny / 2 + nc); j++){
			for (int i = nx / 2 - nc; i <= (nx / 2 + nc); i++){
					sr[i][j] = 0D;
					si[i][j] = 0D;
			}
		}
	}
		
	public void ifft2(int nx, int ny, Graphics g){
		//ifft
		for (int j = 0; j < ny ; j++){
			for(int i = 0; i < nx; i++){
				fr[i]= sr[i][j];
				fi[i]=si[i][j];
				
			}
			fft1(IFFT,128);
			for (int i = 0; i < nx; i++){
				sr[i][j] = fr[i];
				si[i][j] = fi[i];
			}
		}
		
		for(int i = 0; i < nx; i++){
			
			for(int j = 0; j< ny; j++){
				fr[j]=sr[i][j];
				fi[j]=si[i][j];
			}
			fft1(IFFT,128);
			for(int j = 0; j < ny; j++){
				int gray=(int)fr[j];
				if (gray > 255) gray = 255;
				if (gray < 0) gray = 0;
				int pixel = gray * (256*256+256+1);
				setPixel(i,j,pixel, g);
			}
		}
	}
	
	public int power2(int n){
		int result = 1;
		while (n >= 1){
			result = result * 2;
			--n;
		}
		return result;
	}

}

